JUCE: PixelRGB Class Reference

JUCE

Public Types | Public Member Functions | List of all members
PixelRGB Class Reference
juce_graphics » colour

Represents a 24-bit RGB pixel, and can perform compositing operations on it. More...

`#include <juce_PixelFormats.h>`

## Public Types
enum | { indexR = 0 , indexG = 1 , indexB = 2 }
| The indexes of the different components in the byte layout of this type of colour. More...

## Public Member Functions
| PixelRGB () noexcept=default
| Creates a pixel without defining its colour. More...
forcedinline uint32 | getNativeARGB () const noexcept
| Returns a uint32 which represents the pixel in a platform dependent format which is compatible with the native format of a PixelARGB. More...
forcedinline uint32 | getInARGBMaskOrder () const noexcept
| Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue). More...
uint32 | getInARGBMemoryOrder () const noexcept
| Returns a uint32 which when written to memory, will be in the order a, r, g, b. More...
forcedinline uint32 | getEvenBytes () const noexcept
| Return channels with an even index and insert zero bytes between them. More...
forcedinline uint32 | getOddBytes () const noexcept
| Return channels with an odd index and insert zero bytes between them. More...
forcedinline uint8 | getAlpha () const noexcept
forcedinline uint8 | getRed () const noexcept
forcedinline uint8 | getGreen () const noexcept
forcedinline uint8 | getBlue () const noexcept
template<class Pixel >
forcedinline void | set (const Pixel &src) noexcept
| Copies another pixel colour over this one. More...
void | setARGB (uint8, uint8 red, uint8 green, uint8 blue) noexcept
| Sets the pixel's colour from individual components. More...
template<class Pixel >
forcedinline void | blend (const Pixel &src) noexcept
| Blends another pixel onto this one. More...
forcedinline void | blend (PixelRGB src) noexcept
template<class Pixel >
forcedinline void | blend (const Pixel &src, uint32 extraAlpha) noexcept
| Blends another pixel onto this one, applying an extra multiplier to its opacity. More...
template<class Pixel >
forcedinline void | tween (const Pixel &src, uint32 amount) noexcept
| Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount. More...
forcedinline void | setAlpha (uint8) noexcept
| This method is included for compatibility with the PixelARGB class. More...
forcedinline void | multiplyAlpha (int) noexcept
| Multiplies the colour's alpha value with another one. More...
forcedinline void | multiplyAlpha (float) noexcept
| Multiplies the colour's alpha value with another one. More...
forcedinline void | premultiply () noexcept
| Premultiplies the pixel's RGB values by its alpha. More...
forcedinline void | unpremultiply () noexcept
| Unpremultiplies the pixel's RGB values. More...
forcedinline void | desaturate () noexcept

## Detailed Description

Represents a 24-bit RGB pixel, and can perform compositing operations on it.

This is used internally by the imaging classes.

See also
  PixelARGB

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

The indexes of the different components in the byte layout of this type of colour.

Enumerator
indexR |
indexG |
indexB |

## Constructor & Destructor Documentation

## ◆ PixelRGB()

PixelRGB::PixelRGB | ( |  | ) |
| defaultnoexcept

Creates a pixel without defining its colour.

## Member Function Documentation

## ◆ getNativeARGB()

forcedinline uint32 PixelRGB::getNativeARGB | ( |  | ) | const
| noexcept

Returns a uint32 which represents the pixel in a platform dependent format which is compatible with the native format of a PixelARGB.

See also
  PixelARGB::getNativeARGB

References gl::b, gl::g, and gl::r.

## ◆ getInARGBMaskOrder()

forcedinline uint32 PixelRGB::getInARGBMaskOrder | ( |  | ) | const
| noexcept

Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue).

References gl::b, gl::g, and gl::r.

## ◆ getInARGBMemoryOrder()

uint32 PixelRGB::getInARGBMemoryOrder | ( |  | ) | const
| noexcept

Returns a uint32 which when written to memory, will be in the order a, r, g, b.

In other words, if the return-value is read as a uint8 array then the elements will be in the order of a, r, g, b

References gl::b, gl::g, and gl::r.

## ◆ getEvenBytes()

forcedinline uint32 PixelRGB::getEvenBytes | ( |  | ) | const
| noexcept

Return channels with an even index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent but compatible with the return value of getEvenBytes of the PixelARGB class.

See also
  PixelARGB::getEvenBytes

References gl::b, and gl::r.

## ◆ getOddBytes()

forcedinline uint32 PixelRGB::getOddBytes | ( |  | ) | const
| noexcept

Return channels with an odd index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent but compatible with the return value of getOddBytes of the PixelARGB class.

See also
  PixelARGB::getOddBytes

References gl::g.

## ◆ getAlpha()

forcedinline uint8 PixelRGB::getAlpha | ( |  | ) | const
| noexcept

## ◆ getRed()

forcedinline uint8 PixelRGB::getRed | ( |  | ) | const
| noexcept

References gl::r.

## ◆ getGreen()

forcedinline uint8 PixelRGB::getGreen | ( |  | ) | const
| noexcept

References gl::g.

## ◆ getBlue()

forcedinline uint8 PixelRGB::getBlue | ( |  | ) | const
| noexcept

References gl::b.

## ◆ set()

template<class Pixel >

forcedinline void PixelRGB::set | ( | const Pixel & | src | ) |
| noexcept

Copies another pixel colour over this one.

This doesn't blend it - this colour is simply replaced by the other one. Because PixelRGB has no alpha channel, any alpha value in the source pixel is thrown away.

References gl::b, gl::g, gl::r, and gl::src.

## ◆ setARGB()

void PixelRGB::setARGB | ( | uint8 | ,
|  | uint8 | red,
|  | uint8 | green,
|  | uint8 | blue
| ) |  |
| noexcept

Sets the pixel's colour from individual components.

References gl::b, Colours::blue, gl::g, Colours::green, gl::r, and Colours::red.

## ◆ blend() [1/3]

template<class Pixel >

forcedinline void PixelRGB::blend | ( | const Pixel & | src | ) |
| noexcept

Blends another pixel onto this one.

This takes into account the opacity of the pixel being overlaid, and blends it accordingly.

References gl::alpha, gl::b, clampPixelComponents(), gl::g, maskPixelComponents(), gl::r, and gl::src.

## ◆ blend() [2/3]

forcedinline void PixelRGB::blend | ( | PixelRGB | src | ) |
| noexcept

References gl::src.

## ◆ blend() [3/3]

template<class Pixel >

forcedinline void PixelRGB::blend | ( | const Pixel & | src,
|  | uint32 | extraAlpha
| ) |  |
| noexcept

Blends another pixel onto this one, applying an extra multiplier to its opacity.

The opacity of the pixel being overlaid is scaled by the extraAlpha factor before being used, so this can blend semi-transparently from a PixelRGB argument.

References gl::alpha, gl::b, clampPixelComponents(), gl::g, maskPixelComponents(), gl::r, and gl::src.

## ◆ tween()

template<class Pixel >

forcedinline void PixelRGB::tween | ( | const Pixel & | src,
|  | uint32 | amount
| ) |  |
| noexcept

Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount.

References gl::b, gl::g, gl::r, and gl::src.

## ◆ setAlpha()

forcedinline void PixelRGB::setAlpha | ( | uint8 |  | ) |
| noexcept

This method is included for compatibility with the PixelARGB class.

## ◆ multiplyAlpha() [1/2]

forcedinline void PixelRGB::multiplyAlpha | ( | int |  | ) |
| noexcept

Multiplies the colour's alpha value with another one.

## ◆ multiplyAlpha() [2/2]

forcedinline void PixelRGB::multiplyAlpha | ( | float |  | ) |
| noexcept

Multiplies the colour's alpha value with another one.

## ◆ premultiply()

forcedinline void PixelRGB::premultiply | ( |  | ) |
| noexcept

Premultiplies the pixel's RGB values by its alpha.

## ◆ unpremultiply()

forcedinline void PixelRGB::unpremultiply | ( |  | ) |
| noexcept

Unpremultiplies the pixel's RGB values.

## ◆ desaturate()

forcedinline void PixelRGB::desaturate | ( |  | ) |
| noexcept

References gl::b, gl::g, and gl::r.

The documentation for this class was generated from the following file:

- juce_PixelFormats.h